unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, HgHGrid, HgGrid, StdCtrls, HgSpreadsheet;

type
  TForm1 = class(TForm)
    HyperSpreadsheet1: THyperSpreadsheet;
    Memo1: TMemo;
    Edit1: TEdit;
    procedure FormShow(Sender: TObject);
    procedure HyperSpreadsheet1CellEdited(Sender: TObject; ACol,
      ARow: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HyperSpreadsheet1GetEditText(Sender: TObject; ACol,
      ARow: Integer; var Value: String);
    procedure HyperSpreadsheet1SetEditText(Sender: TObject; ACol,
      ARow: Integer; const Value: String);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormShow(Sender: TObject);
var
  C : Integer;
  S : string;
begin
  HyperSpreadsheet1.LoadFromFile( 0 , 0 , ExtractFilePath( Application.ExeName ) + '\grid.txt' );
  S := 'A';
  for C := 0 to Pred( HyperSpreadsheet1.ColCount ) do
    begin
      HyperSpreadsheet1.Cells[ C , 0 ] := S;
      if S[ Length( S ) ] = 'Z' then
        S := StringOfChar( 'A' , Length(S ) + 1 )
      else
        Inc( S[ Length( S ) ] );
    end;
end;

procedure TForm1.HyperSpreadsheet1CellEdited(Sender: TObject; ACol,
  ARow: Integer);
begin
  Memo1.Lines.Add( 'edited ' + Format( '%d,%d' , [ ACol , ARow ] ) );
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  HyperSpreadsheet1.SaveToFile( 0 , 0 , ExtractFilePath( Application.ExeName ) + '\grid.txt' );
end;

procedure TForm1.HyperSpreadsheet1GetEditText(Sender: TObject; ACol,
  ARow: Integer; var Value: String);
begin
  Edit1.OnChange := nil;
  Edit1.Text := Value;
  Edit1.onChange := Edit1Change;
end;

procedure TForm1.HyperSpreadsheet1SetEditText(Sender: TObject; ACol,ARow: Integer; const Value: String);
begin
  Edit1.OnChange := nil;
  Edit1.Text := Value;
  Edit1.onChange := Edit1Change;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  HyperSpreadsheet1.Cells[ HyperSpreadSheet1.Col , HyperSpreadSheet1.Row ] := Edit1.Text;
end;

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if Ord( Key )= VK_RETURN then
    begin
      Key := #0;
      HyperSpreadsheet1.Refresh;
    end;
end;

end.
